"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.simulate = void 0;
const rpc_1 = require("@project-serum/anchor/dist/cjs/utils/rpc");
class SimulateError extends Error {
    constructor(simulationResponse, message) {
        super(message);
        this.simulationResponse = simulationResponse;
    }
}
async function simulate(tx, signers, commitment, includeAccounts) {
    tx.feePayer = this.wallet.publicKey;
    tx.recentBlockhash = (await this.connection.getLatestBlockhash(commitment !== null && commitment !== void 0 ? commitment : this.connection.commitment)).blockhash;
    const result = await (0, rpc_1.simulateTransaction)(this.connection, tx);
    if (result.value.err) {
        throw new SimulateError(result.value);
    }
    return result.value;
}
exports.simulate = simulate;
//# sourceMappingURL=anchor.js.map