import { Market } from '@project-serum/serum';
import { PriceData } from '@pythnetwork/client';
import { PublicKey } from '@solana/web3.js';
import { MangoClient } from '../client';
import { Id } from '../ids';
import { Bank, MintInfo } from './bank';
import { PerpMarket } from './perp';
import { Serum3Market } from './serum3';
export declare class Group {
    publicKey: PublicKey;
    creator: PublicKey;
    groupNum: number;
    admin: PublicKey;
    fastListingAdmin: PublicKey;
    insuranceMint: PublicKey;
    insuranceVault: PublicKey;
    testing: number;
    version: number;
    banksMap: Map<string, Bank>;
    serum3MarketsMap: Map<string, Serum3Market>;
    serum3MarketExternalsMap: Map<string, Market>;
    perpMarketsMap: Map<string, PerpMarket>;
    mintInfosMap: Map<number, MintInfo>;
    oraclesMap: Map<string, PriceData>;
    static from(publicKey: PublicKey, obj: {
        creator: PublicKey;
        groupNum: number;
        admin: PublicKey;
        fastListingAdmin: PublicKey;
        insuranceMint: PublicKey;
        insuranceVault: PublicKey;
        testing: number;
        version: number;
    }): Group;
    constructor(publicKey: PublicKey, creator: PublicKey, groupNum: number, admin: PublicKey, fastListingAdmin: PublicKey, insuranceMint: PublicKey, insuranceVault: PublicKey, testing: number, version: number, banksMap: Map<string, Bank>, serum3MarketsMap: Map<string, Serum3Market>, serum3MarketExternalsMap: Map<string, Market>, perpMarketsMap: Map<string, PerpMarket>, mintInfosMap: Map<number, MintInfo>, oraclesMap: Map<string, PriceData>);
    findBank(tokenIndex: number): Bank | undefined;
    findSerum3Market(marketIndex: number): Serum3Market | undefined;
    reloadAll(client: MangoClient): Promise<void>;
    reloadBanks(client: MangoClient, ids?: Id): Promise<void>;
    reloadMintInfos(client: MangoClient, ids?: Id): Promise<void>;
    reloadSerum3Markets(client: MangoClient, ids?: Id): Promise<void>;
    reloadSerum3ExternalMarkets(client: MangoClient, ids?: Id): Promise<void>;
    reloadPerpMarkets(client: MangoClient, ids?: Id): Promise<void>;
    reloadBankPrices(client: MangoClient, ids?: Id): Promise<void>;
    toString(): string;
}
