import { I80F48, I80F48Dto } from './I80F48';
import { HealthType } from './mangoAccount';
export declare class HealthCache {
    tokenInfos: TokenInfo[];
    serum3Infos: Serum3Info[];
    perpInfos: PerpInfo[];
    constructor(dto: HealthCacheDto);
    health(healthType: HealthType): I80F48;
}
export declare class TokenInfo {
    constructor(dto: TokenInfoDto);
    tokenIndex: number;
    maintAssetWeight: I80F48;
    initAssetWeight: I80F48;
    maintLiabWeight: I80F48;
    initLiabWeight: I80F48;
    oraclePrice: I80F48;
    balance: I80F48;
    serum3MaxReserved: I80F48;
    assetWeight(healthType: HealthType): I80F48;
    liabWeight(healthType: HealthType): I80F48;
    healthContribution(healthType: HealthType): I80F48;
}
export declare class Serum3Info {
    constructor(dto: Serum3InfoDto);
    reserved: I80F48;
    baseIndex: number;
    quoteIndex: number;
    healthContribution(healthType: HealthType, tokenInfos: TokenInfo[]): I80F48;
}
export declare class PerpInfo {
    constructor(dto: PerpInfoDto);
    maintAssetWeight: I80F48;
    initAssetWeight: I80F48;
    maintLiabWeight: I80F48;
    initLiabWeight: I80F48;
    base: I80F48;
    quote: I80F48;
    healthContribution(healthType: HealthType): I80F48;
}
export declare class HealthCacheDto {
    tokenInfos: TokenInfoDto[];
    serum3Infos: Serum3InfoDto[];
    perpInfos: PerpInfoDto[];
}
export declare class TokenInfoDto {
    tokenIndex: number;
    maintAssetWeight: I80F48Dto;
    initAssetWeight: I80F48Dto;
    maintLiabWeight: I80F48Dto;
    initLiabWeight: I80F48Dto;
    oraclePrice: I80F48Dto;
    balance: I80F48Dto;
    serum3MaxReserved: I80F48Dto;
}
export declare class Serum3InfoDto {
    reserved: I80F48Dto;
    baseIndex: number;
    quoteIndex: number;
}
export declare class PerpInfoDto {
    maintAssetWeight: I80F48Dto;
    initAssetWeight: I80F48Dto;
    maintLiabWeight: I80F48Dto;
    initLiabWeight: I80F48Dto;
    base: I80F48Dto;
    quote: I80F48Dto;
}
