/// <reference types="bn.js" />
import { BN } from '@project-serum/anchor';
import { PublicKey } from '@solana/web3.js';
import { OracleConfig } from './bank';
import { I80F48, I80F48Dto } from './I80F48';
export declare class PerpMarket {
    publicKey: PublicKey;
    group: PublicKey;
    baseTokenIndex: number;
    quoteTokenIndex: number;
    perpMarketIndex: number;
    oracle: PublicKey;
    bids: PublicKey;
    asks: PublicKey;
    eventQueue: PublicKey;
    quoteLotSize: BN;
    baseLotSize: BN;
    baseTokenDecimals: number;
    registrationTime: BN;
    name: string;
    maintAssetWeight: I80F48;
    initAssetWeight: I80F48;
    maintLiabWeight: I80F48;
    initLiabWeight: I80F48;
    liquidationFee: I80F48;
    makerFee: I80F48;
    takerFee: I80F48;
    openInterest: number;
    seqNum: number;
    feesAccrued: I80F48;
    static from(publicKey: PublicKey, obj: {
        group: PublicKey;
        baseTokenIndex: number;
        quoteTokenIndex: number;
        perpMarketIndex: number;
        name: number[];
        oracle: PublicKey;
        oracleConfig: OracleConfig;
        bids: PublicKey;
        asks: PublicKey;
        eventQueue: PublicKey;
        quoteLotSize: BN;
        baseLotSize: BN;
        maintAssetWeight: I80F48Dto;
        initAssetWeight: I80F48Dto;
        maintLiabWeight: I80F48Dto;
        initLiabWeight: I80F48Dto;
        liquidationFee: I80F48Dto;
        makerFee: I80F48Dto;
        takerFee: I80F48Dto;
        minFunding: I80F48Dto;
        maxFunding: I80F48Dto;
        impactQuantity: BN;
        longFunding: I80F48Dto;
        shortFunding: I80F48Dto;
        fundingLastUpdated: BN;
        openInterest: BN;
        seqNum: any;
        feesAccrued: I80F48Dto;
        bump: number;
        baseTokenDecimals: number;
        registrationTime: BN;
    }): PerpMarket;
    constructor(publicKey: PublicKey, group: PublicKey, baseTokenIndex: number, quoteTokenIndex: number, perpMarketIndex: number, name: number[], oracle: PublicKey, oracleConfig: OracleConfig, bids: PublicKey, asks: PublicKey, eventQueue: PublicKey, quoteLotSize: BN, baseLotSize: BN, maintAssetWeight: I80F48Dto, initAssetWeight: I80F48Dto, maintLiabWeight: I80F48Dto, initLiabWeight: I80F48Dto, liquidationFee: I80F48Dto, makerFee: I80F48Dto, takerFee: I80F48Dto, minFunding: I80F48Dto, maxFundingI80F48Dto: any, impactQuantity: BN, longFunding: I80F48Dto, shortFunding: I80F48Dto, fundingLastUpdated: BN, openInterest: BN, seqNum: BN, feesAccrued: I80F48Dto, bump: number, baseTokenDecimals: number, registrationTime: BN);
    uiToNativePriceQuantity(price: number, quantity: number): [BN, BN];
    uiQuoteToLots(uiQuote: number): BN;
    toString(): string;
}
export declare class Side {
    static bid: {
        bid: {};
    };
    static ask: {
        ask: {};
    };
}
export declare class OrderType {
    static limit: {
        limit: {};
    };
    static immediateOrCancel: {
        immediateorcancel: {};
    };
    static postOnly: {
        postonly: {};
    };
    static market: {
        market: {};
    };
    static postOnlySlide: {
        postonlyslide: {};
    };
}
