import { PublicKey } from '@solana/web3.js';
import BN from 'bn.js';
export declare class Serum3Market {
    publicKey: PublicKey;
    group: PublicKey;
    baseTokenIndex: number;
    quoteTokenIndex: number;
    serumProgram: PublicKey;
    serumMarketExternal: PublicKey;
    marketIndex: number;
    registrationTime: BN;
    name: string;
    static from(publicKey: PublicKey, obj: {
        group: PublicKey;
        baseTokenIndex: number;
        quoteTokenIndex: number;
        name: number[];
        serumProgram: PublicKey;
        serumMarketExternal: PublicKey;
        marketIndex: number;
        bump: number;
        registrationTime: BN;
    }): Serum3Market;
    constructor(publicKey: PublicKey, group: PublicKey, baseTokenIndex: number, quoteTokenIndex: number, name: number[], serumProgram: PublicKey, serumMarketExternal: PublicKey, marketIndex: number, registrationTime: BN);
}
export declare class Serum3SelfTradeBehavior {
    static decrementTake: {
        decrementTake: {};
    };
    static cancelProvide: {
        cancelProvide: {};
    };
    static abortTransaction: {
        abortTransaction: {};
    };
}
export declare class Serum3OrderType {
    static limit: {
        limit: {};
    };
    static immediateOrCancel: {
        immediateOrCancel: {};
    };
    static postOnly: {
        postOnly: {};
    };
}
export declare class Serum3Side {
    static bid: {
        bid: {};
    };
    static ask: {
        ask: {};
    };
}
